AppTitle "Coat Getting Simulator - PC (2001 by FishyFish)"



;This game is based upon the Sinclair Spectrum version by Russell Tayler.

;At the time of coding (Feb 2001) I was still pretty new to Blitz Basic,

;so please excuse any 'kludgy' or pointless code.



;===============================================================

;set graphics stuff

Const width = 640, height = 480

Graphics width,height

SetFont LoadFont( "arial",24,True )

SetBuffer BackBuffer()

;===============================================================

; load images and set up variables

Global player = LoadAnimImage("images/player.bmp",64,55,0,2)

Global coatstand = LoadAnimImage("images/coatstand.bmp",28,53,0,3)

Global brolly = LoadAnimImage("images/brolly.bmp",49,53,0,2)

Global bonus = LoadAnimImage("images/bonus.bmp",48,48,0,4)

Global uea = LoadAnimImage("images/uea.bmp",39,50,0,2)

Global coat = LoadImage("images/coat.bmp")

Global boot = LoadImage("images/boots.bmp")

Global grave = LoadImage("images/grave.bmp")

Global leftwall = LoadImage("images/leftwall.bmp")

Global topwall = LoadImage("images/topwall.bmp")

Global bottomwall = LoadImage("images/bottomwall.bmp")

Global rightwall = LoadImage("images/rightwall.bmp")

Global Floor = LoadImage("images/floor.bmp")

Global gameover = LoadImage("images/gameover2.bmp")

Global startscreen = LoadImage("images/startscreen.bmp")

Global title = LoadAnimImage("images/title.bmp",94,11,0,3)

Global bump = LoadSound("bump.wav")

Global coatnoise = LoadSound("coat.wav")

Global scream = LoadSound("scream.wav")

Global mmmmm = LoadSound("mmmmm.wav")

Global burp = LoadSound("burp.wav")

Global heehee = LoadSound("heehee.wav")

Global brollynoise = LoadSound("umbrella.wav")



Global player_x = 16	;players x coordinate

Global player_y = 220	;players y coordinate

Global player_vel = 4	;players velocity

Global bootson = 0		;player wearing boots?

Global player_f = 0		;players animation frame

Global animcounter = 1

Global x,y				

Global score = 0		;score

Global complete = 0		;level complete?

Global dead = 0			;player dead?

Global lives = 0		;

Global protect = 0		;player invulnerable?

Global level = 1		;Playing level

Global chance			;sets random chance of bonus objects appearing

Global screencounter = 0;timer for gameover screen

Global bootcounter = 0	;timer for magic boots

Global deathcounter = 0 ;timer to display gravestone

Global gravestone = 0	;variable to prevent gravestone from screaming.



;===============================================================

; Set up types

Type coatstands

Field coat_x, coat_y, coat_dirx, coat_diry, coat_velx, coat_vely, coat_f

End Type



Type homer

Field homer_x, homer_y, homer_dirx, homer_diry, homer_velx, homer_vely

End Type



Type brollys

Field brolly_x, brolly_y, brolly_col

End Type



Type coat

Field coat_xpos, coat_ypos

End Type



Type boot

Field boot_x, boot_y

End Type



Type bonus

Field bonus_x, bonus_y, bonus_f

End Type

;===============================================================



; show splash screen and create objects

startup()

createcoatstands()

If Rnd(10) < 7 Then createbrollys()

createcoat()

If Rnd(10) > 7 Then createboots()

createbonus()



;===============================================================

;Main loop



timer=CreateTimer(30)



While Not KeyDown(1)



	frames = WaitTimer(timer)

	For k = 1 To frames

	

	boottimer()

	death()

	If lives = 0 Then moveplayer() 

	If complete=1 Then 

	level = level + 1

	nextlevel()

	End If

	

	Next

	

	Cls

	

	drawroom()

	drawplayer()

	boot()

	drawbonus()

	movecoatstands()

	moveuea()

	brolly()

	coat()

	score()

	

	Flip



Wend



;===============================================================



; --- FUNCTIONS ---

;=======================================================================================

; function to move player around screen

Function moveplayer()



If KeyDown(203) Then

	player_x = player_x - player_vel

End If

If KeyDown(205) Then

	player_x = player_x + player_vel

End If

If KeyDown(208) Then

	player_y = player_y + player_vel

End If

If KeyDown(200) Then

	player_y = player_y - player_vel

End If



If animcounter = 5 Then

player_f = player_f + 1

End If

animcounter = animcounter + 1



If player_x < 18 Then player_x = 18

If player_x > 552 Then player_x = 552

If player_y < 33 Then player_y = 33

If player_y > 392 Then player_y = 392

If player_f >1 Then player_f = 0

If animcounter > 5 Then animcounter = 1





End Function



;=======================================================================================

; function to draw player

Function drawplayer()



	If lives = 1 Then DrawImage grave,player_x,player_y

	If lives = 0 Then DrawImage player,player_x,player_y,player_f



End Function

;=======================================================================================

; function to create coatstands

Function createcoatstands()

	count = 1

	

	For t = 1 To count

	e.coatstands = New coatstands

	e\coat_x = Rnd(256,600)

	e\coat_y = Rnd(34,400)

	e\coat_dirx=Rnd(1)

	e_coat_diry=Rnd(1)

	e\coat_velx = Rnd(1,3)

	e\coat_vely = Rnd(3,5)

	e\coat_f = 0

	Next

	

End Function



;=======================================================================================

; function to move coatstands around screen

Function movecoatstands()



	For e.coatstands = Each coatstands

	

	If e\coat_dirx = 0 Then 

		e\coat_x = e\coat_x + (e\coat_velx + Rnd(-2,2))

	End If

	

	If e\coat_dirx = 1 Then 

		e\coat_x = e\coat_x - (e\coat_velx + Rnd(-2,2))

	End If

	

	If e\coat_diry = 0 Then 

		e\coat_y = e\coat_y + (e\coat_vely + Rnd(-2,2))

	End If

	

	If e\coat_diry = 1 Then 

		e\coat_y = e\coat_y - (e\coat_vely + Rnd(-2,2))

	End If

	

	If e\coat_x > 575 Then e\coat_dirx = 1: PlaySound bump

	If e\coat_x < 33 Then e\coat_dirx = 0: PlaySound bump

	If e\coat_y > 394 Then e\coat_diry = 1: PlaySound bump

	If e\coat_y < 33 Then e\coat_diry = 0: PlaySound bump

		

	If bootson = 0 Then DrawImage coatstand,e\coat_x,e\coat_y,0

	If bootson = 1 Then DrawImage coatstand,e\coat_x,e\coat_y,1

	If bootson = 1 And bootcounter > 160 Then DrawImage coatstand,e\coat_x,e\coat_y,2

	

	Next



End Function



;=======================================================================================

; function to create homing UEA man

Function createuea()

	count = 1

	

	For t = 1 To count

	e.homer = New homer

	e\homer_x = Rnd(550,600)

	e\homer_y = Rnd(34,400)

	e\homer_velx = 1

	e\homer_vely = 1

	Next

	

End Function



;=======================================================================================

; function to move homing UEA man around screen

Function moveuea()



	For h.homer = Each homer

	

	If h\homer_x < player_x And bootson = 0 Then 

	h\homer_x = h\homer_x + h\homer_velx

	Else If h\homer_x < player_x And bootson = 1 Then 

	h\homer_x = h\homer_x - h\homer_velx

	End If

	

	If h\homer_x > player_x And bootson = 0 Then 

	h\homer_x = h\homer_x - h\homer_velx

	Else If h\homer_x > player_x And bootson = 1 Then 

	h\homer_x = h\homer_x + h\homer_velx

	End If

	

	If h\homer_y < player_y And bootson = 0 Then 

	h\homer_y = h\homer_y + h\homer_vely

	Else If h\homer_y < player_y And bootson = 1 Then 

	h\homer_y = h\homer_y - h\homer_vely

	End If

	

	If h\homer_y > player_y And bootson = 0 Then 

	h\homer_y = h\homer_y - h\homer_vely

	Else If h\homer_y > player_y And bootson = 1 Then 

	h\homer_y = h\homer_y + h\homer_vely

	End If

	

	If h\homer_x > 564 Then h\homer_x = 564

	If h\homer_x < 33 Then h\homer_x = 33

	If h\homer_y > 397 Then h\homer_y = 397

	If h\homer_y < 33 Then h\homer_y = 33

	

	If bootson = 0 Then DrawImage uea,h\homer_x,h\homer_y,0:h\homer_velx = 1: h\homer_vely=1

	If bootson = 1 Then DrawImage uea,h\homer_x,h\homer_y,1:h\homer_velx = 3: h\homer_vely=3

	

	Next



End Function





;=======================================================================================

; function to check for player death

Function death()

	

	If lives = 1 Then deathcounter = deathcounter + 1

	If deathcounter = 100 Then gameover()

	

	For e.coatstands = Each coatstands

	

	If gravestone = 0 And ImagesCollide ( coatstand,e\coat_x,e\coat_y,0,player,player_x,player_y,0 ) Then 

	lives = 1: gravestone = 1

	If protect = 1 Then lives = 0

	If lives = 0 Then gravestone = 0

	If protect = 0  And gravestone = 1 Then PlaySound scream

	If bootson = 1 Then score = score + 100: Delete e: PlaySound burp

	End If

		

	Next

	

	For h.homer = Each homer

	

	If gravestone = 0 And ImagesCollide ( coatstand,h\homer_x,h\homer_y,0,player,player_x,player_y,0 ) Then	

	lives = 1: gravestone = 1

	If protect = 1 Then lives = 0

	If lives = 0 Then gravestone = 0

	If protect = 0  And gravestone = 1 Then PlaySound scream

	If bootson = 1 Then score = score + 200: Delete h: PlaySound burp

	End If

	

	Next

	

End Function



;=======================================================================================

; function to draw gameover screen

Function gameover()



		If lives = 1 Then

		While Not KeyDown(57)

		Cls

		screencounter = screencounter + 1

	

		If screencounter <= 1000 Then

		DrawImage(gameover,193,176)

		Color 128,128,128

		Text 240,128,"final score: "+score

		End If

		

		If screencounter > 1000 Then

		Cls

		DrawImage(startscreen,95,4)

		End If

		

		Flip

		

		If KeyDown(1) Then End

		

		Wend

		resetvars()

		End If

		

End Function





;=======================================================================================

; function to create brollys

Function createbrollys()

	count = 1

	

	For t = 1 To count

	b.brollys = New brollys

	b\brolly_x = Rnd(200,394)

	b\brolly_y = Rnd(86,396)

	b\brolly_col=Rnd(1)

	Next

	

End Function





;=======================================================================================

; function to draw brollys

Function brolly()

	For b.brollys = Each brollys

	

	DrawImage brolly,b\brolly_x,b\brolly_y,b\brolly_col

	If ImagesCollide(brolly,b\brolly_x,b\brolly_y,b\brolly_col,player,player_x,player_y,0)

	protect=1

	score = score + 25

	PlaySound brollynoise

	Delete b

	End If

	

	Next

	

End Function



;=======================================================================================

; function to create coat

Function createcoat()

	count = 1

	

	For t = 1 To count

	c.coat = New coat

	c\coat_xpos = 560

	c\coat_ypos = Rnd(34,406)

	Next

	

End Function



;=======================================================================================

; function to draw coat

Function coat()

	For c.coat = Each coat

	

	DrawImage coat,c\coat_xpos,c\coat_ypos

	If ImagesCollide(coat,c\coat_xpos,c\coat_ypos,0,player,player_x,player_y,0)

	score = score + 50

	complete = 1

	PlaySound coatnoise

	End If



	Next

	

End Function



;=======================================================================================

; function to create boots

Function createboots()

	count = 1

	

	For t = 1 To count

	s.boot = New boot

	s\boot_x = Rnd(64,394)

	s\boot_y = Rnd(86,396)

	Next

	

End Function



;=======================================================================================

; function to draw boots

Function boot()

	For s.boot = Each boot

	

	DrawImage boot,s\boot_x,s\boot_y

	If ImagesCollide(boot,s\boot_x,s\boot_y,0,player,player_x,player_y,0)

	score = score + 50

	PlaySound heehee

	Delete s

	bootson=1

	protect=1

		

	End If



	Next

	

End Function



;=======================================================================================

; function to time boots

Function boottimer()

	

	If bootson = 1 Then

	bootcounter = bootcounter + 1

	End If

	

	If bootcounter > 200 Then

	bootson = 0

	protect = 0

	bootcounter = 0

	End If

	

End Function





;=======================================================================================

; function to create bonus items

Function createbonus()

	count = 1

	

	For t = 1 To count

	p.bonus = New bonus

	p\bonus_x = Rnd(200,500)

	p\bonus_y = Rnd(86,396)

	p\bonus_f=Rnd(3)

	Next

	

End Function



;=======================================================================================

; function to draw bonus items

Function drawbonus()

	For p.bonus = Each bonus

	

	DrawImage bonus,p\bonus_x,p\bonus_y, p\bonus_f

	If ImagesCollide(bonus,p\bonus_x,p\bonus_y,p\bonus_f,player,player_x,player_y,0)

	score = score + ((p\bonus_f * 100)+100)

	PlaySound mmmmm

	Delete p

	End If



	Next

	

End Function



;=======================================================================================

; function to draw walls and floor

Function drawroom()

	

	TileBlock Floor,128

	DrawImage(leftwall,0,0)

	DrawImage(topwall,33,0)

	DrawImage(bottomwall,33,447)

	DrawImage(rightwall,602,0)

	

End Function



;------------------------------------------------------

;Score

Function score()



	Color 0,0,0

	Rect 100,2,440,27

	Color 255,64,64

	Text 120,4,"Score: "+score

	Text 440,4,"Level: "+level

	If bootson = 0 Then DrawImage title,276,10,0

	If bootson = 1 And bootcounter <= 160 Then DrawImage title,276,10,1

	If bootson = 1 And bootcounter > 160 Then DrawImage title,276,10,2

	

End Function



;------------------------------------------------------

;Reset all variables

Function resetvars()

	player_x = 16

	player_y = 220

	player_f = 0

	player_vel=4

	fcounter = 0

	score = 0

	complete = 0

	dead = 0

	lives = 0

	protect = 0

	level = 1

	deathcounter = 0

	screencounter=0

	bootcounter=0

	gravestone=0

	deletetypes()

	createcoat()

	createcoatstands()

	createbrollys()

	

End Function



;=======================================================================================

; Delete types

Function deletetypes()

	For c.coat = Each coat

	Delete c

	Next

	

	For e.coatstands = Each coatstands

	Delete e

	Next

	

	For b.brollys = Each brollys

	Delete b

	Next

	

	For h.homer = Each homer

	Delete h

	Next

	

	For s.boot = Each boot

	Delete s

	Next

	

	For p.bonus = Each bonus

	Delete p

	Next

End Function



;=======================================================================================

; Function to show splash screen on startup.

Function startup()

	

	While Not KeyDown(57)



	Cls

	DrawImage(startscreen,95,4)

	Flip

	

Wend

	

End Function



;=======================================================================================

; Function to increase difficulty.

Function nextlevel()

	

	chance = Rnd(15)

	

	deletetypes()

	

	For e.coatstands = Each coatstands

	e\coat_x = Rnd(256,600)

	Next

	

	createcoat()

	For c.coat = Each coat

	c\coat_ypos = Rnd(34,406)

	Next

	



	If level < 8 Then

	For num = 1 To level

	createcoatstands()

	Next

	Else For num = 1 To 8

	createcoatstands()

	Next

	End If

	

	If level > 14 Then

	createuea()

	End If

	

	If chance > 10 Then createboots()

	If chance < 5 Then createbrollys()

	If chance > 12 Then createbonus()

	

	player_x = 16

	player_y = 220

	bootson=0

	protect = 0

	complete = 0

	bootcounter=0

	deathcounter=0

	gravestone = 0



	While Not KeyDown(57)

	Cls

	Color 255,255,0

	Text 320,180,"Level "+(level-1)+" completed",1,0

	Text 320,240,"You have scored "+score+" points",1,0

	Text 320,300,"Press 'Space' to continue",1,0

	Flip

	Wend

	



	

End Function